LibIdealConsumer Class Reference

Records library interface output into a BigIdeal. More...

`#include <LibTest.h>`

Inheritance diagram for LibIdealConsumer:

## Public Member Functions

| LibIdealConsumer (const VarNames &names)
virtual void | idealBegin (size_t varCount)
| Called before output of a monomial ideal.
virtual void | consume (mpz_ptr *exponentVector)
| For output of a generator of the ideal.
const BigIdeal & | getIdeal () const
| Returns the recorded ideal in a canonical form.
bool | hasAnyOutput () const
| Returns whether any ideal has been recorded.
Public Member Functions inherited from Frobby::IdealConsumer
virtual | ~IdealConsumer ()
| The provided implementation does nothing.
virtual void | idealEnd ()
| Called after output of a monomial ideal.

## Private Attributes

bool | _hasAnyOutput
BigIdeal | _ideal

## Detailed Description

Records library interface output into a BigIdeal.

Definition at line 39 of file LibTest.h.

## Constructor & Destructor Documentation

## LibIdealConsumer()

LibIdealConsumer::LibIdealConsumer | ( | const VarNames & | names | ) |

Definition at line 48 of file LibTest.cpp.

## Member Function Documentation

## consume()

void LibIdealConsumer::consume | ( | mpz_ptr * | exponentVector | ) |

virtual

For output of a generator of the ideal.

exponentVector is an array containing the exponents of the generator.

The parameter exponentVector and its entries must not be altered or deallocated, and no reference to them can be retained after the consume method has returned. If the output must be stored, then a copy must be made.

Implements Frobby::IdealConsumer.

Definition at line 60 of file LibTest.cpp.

## getIdeal()

const BigIdeal & LibIdealConsumer::getIdeal | ( |  | ) | const

Returns the recorded ideal in a canonical form.

Definition at line 66 of file LibTest.cpp.

## hasAnyOutput()

bool LibIdealConsumer::hasAnyOutput | ( |  | ) | const

Returns whether any ideal has been recorded.

Definition at line 71 of file LibTest.cpp.

## idealBegin()

void LibIdealConsumer::idealBegin | ( | size_t | varCount | ) |

virtual

Called before output of a monomial ideal.

varCount is the number of variables of the ring within which the output ideal lies. The provided implementation does nothing.

Reimplemented from Frobby::IdealConsumer.

Definition at line 53 of file LibTest.cpp.

## Member Data Documentation

## _hasAnyOutput

bool LibIdealConsumer::_hasAnyOutput

private

Definition at line 53 of file LibTest.h.

## _ideal

BigIdeal LibIdealConsumer::_ideal

mutable private

Definition at line 54 of file LibTest.h.

The documentation for this class was generated from the following files:

- src/LibTest.h
- src/LibTest.cpp